3 USAGE
='[help|start|bad|good|skip|next|reset|visualize|replay|log|run]'
4 LONG_USAGE
='git bisect help
5 print this long help message.
6 git bisect start [<bad> [<good>...]] [--] [<pathspec>...]
7 reset bisect state and start bisection.
9 mark <rev> a known-bad revision.
10 git bisect good [<rev>...]
11 mark <rev>... known-good revisions.
12 git bisect skip [<rev>...]
13 mark <rev>... untestable revisions.
15 find next bisection to test and check it out.
16 git bisect reset [<branch>]
17 finish bisection search and go back to branch.
19 show bisect status in gitk.
20 git bisect replay <logfile>
24 git bisect run <cmd>...
25 use <cmd>... to automatically bisect.
27 Please use "git help bisect" to get the full man page.'
33 _x40
='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
34 _x40
="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
39 s/'\''/'\'\\\\\'\''/g;
47 test -s "$GIT_DIR/BISECT_START" ||
{
48 echo >&2 'You need to start by "git bisect start"'
51 echo >&2 -n 'Do you want me to do it for you [Y/n]? '
68 head=$
(GIT_DIR
="$GIT_DIR" git symbolic-ref
-q HEAD
) ||
69 head=$
(GIT_DIR
="$GIT_DIR" git rev-parse
--verify HEAD
) ||
70 die
"Bad HEAD - I need a HEAD"
73 # Check if we are bisecting.
76 if test -s "$GIT_DIR/BISECT_START"
78 # Reset to the rev from where we started.
79 start_head
=$
(cat "$GIT_DIR/BISECT_START")
80 git checkout
"$start_head" ||
exit
82 # Get rev from where we start.
85 # This error message should only be triggered by
86 # cogito usage, and cogito users should understand
87 # it relates to cg-seek.
88 [ -s "$GIT_DIR/head-name" ] &&
89 die
"won't bisect on seeked tree"
90 start_head
="${head#refs/heads/}"
93 die
"Bad HEAD - strange symbolic ref"
99 # Get rid of any old bisect state.
101 bisect_clean_state ||
exit
104 # Check for one bad and then some good revisions.
108 case "$arg" in --) has_double_dash
=1; break ;; esac
113 while [ $# -gt 0 ]; do
121 rev=$
(git rev-parse
-q --verify "$arg^{commit}") ||
{
122 test $has_double_dash -eq 1 &&
123 die
"'$arg' does not appear to be a valid revision"
127 0) state
='bad' ; bad_seen
=1 ;;
130 eval="$eval bisect_write '$state' '$rev' 'nolog'; "
138 # In case of mistaken revs or checkout error, or signals received,
139 # "bisect_auto_next" below may exit or misbehave.
140 # We have to trap this to be able to clean up using
141 # "bisect_clean_state".
143 trap 'bisect_clean_state' 0
144 trap 'exit 255' 1 2 3 15
147 # Write new start state.
149 echo "$start_head" >"$GIT_DIR/BISECT_START" &&
150 sq "$@" >"$GIT_DIR/BISECT_NAMES" &&
152 echo "git bisect start$orig_args" >>"$GIT_DIR/BISECT_LOG" ||
exit
154 # Check if we can proceed to the next bisect state.
167 good|skip
) tag
="$state"-"$rev" ;;
168 *) die
"Bad bisect_write argument: $state" ;;
170 git update-ref
"refs/bisect/$tag" "$rev" ||
exit
171 echo "# $state: $(git show-branch $rev)" >>"$GIT_DIR/BISECT_LOG"
172 test -n "$nolog" ||
echo "git bisect $state $rev" >>"$GIT_DIR/BISECT_LOG"
180 die
"Please call 'bisect_state' with at least one argument." ;;
182 rev=$
(git rev-parse
--verify HEAD
) ||
183 die
"Bad rev input: HEAD"
184 bisect_write
"$state" "$rev" ;;
190 sha
=$
(git rev-parse
--verify "$rev^{commit}") ||
191 die
"Bad rev input: $rev"
192 eval="$eval bisect_write '$state' '$sha'; "
196 die
"'git bisect bad' can take only one argument." ;;
203 bisect_next_check
() {
204 missing_good
= missing_bad
=
205 git show-ref
-q --verify refs
/bisect
/bad || missing_bad
=t
206 test -n "$(git for-each-ref "refs
/bisect
/good-
*")" || missing_good
=t
208 case "$missing_good,$missing_bad,$1" in
210 : have both good and bad
- ok
213 # do not have both but not asked to fail - just report.
217 # have bad but not good. we could bisect although
218 # this is less optimum.
219 echo >&2 'Warning: bisecting only with a bad commit.'
222 printf >&2 'Are you sure [Y/n]? '
224 case "$yesno" in [Nn
]*) exit 1 ;; esac
226 : bisect without good...
230 test -s "$GIT_DIR/BISECT_START" ||
{
231 echo >&2 'You need to start by "git bisect start".'
234 echo >&2 'You '$THEN'need to give me at least one good' \
235 'and one bad revisions.'
236 echo >&2 '(You can use "git bisect bad" and' \
237 '"git bisect good" for that.)'
243 bisect_next_check
&& bisect_next ||
:
252 if [ $res -ne 0 ]; then
253 echo >&2 "'git rev-list --bisect-vars' failed:"
254 echo >&2 "maybe you mistake good and bad revs?"
265 if [ -z "$_skip" ]; then
266 eval_rev_list
"$_eval" |
{
276 # Let's parse the output of:
277 # "git rev-list --bisect-vars --bisect-all ..."
278 eval_rev_list
"$_eval" |
{
282 case "$VARS,$FOUND,$TRIED,$hash" in
284 # "bisect_foo=bar" read from rev-list output.
291 # We had nothing to search.
292 echo "bisect_rev= &&"
296 # We did not find a good bisect rev.
297 # This should happen only if the "bad"
298 # commit is also a "skip" commit.
299 echo "bisect_rev='$TRIED' &&"
304 TRIED
="${TRIED:+$TRIED|}$hash"
308 echo "bisect_rev=$hash &&"
309 echo "bisect_tried='$TRIED' &&"
315 # We have already found a rev to be tested.
322 echo "die 'filter_skipped error'"
323 die
"filter_skipped error " \
336 exit_if_skipped_commits
() {
338 if expr "$_tried" : ".*[|].*" > /dev
/null
; then
339 echo "There are only 'skip'ped commit left to test."
340 echo "The first bad commit could be any of:"
341 echo "$_tried" |
tr '[|]' '[\012]'
342 echo "We cannot bisect more!"
348 case "$#" in 0) ;; *) usage
;; esac
350 bisect_next_check good
352 skip
=$
(git for-each-ref
--format='%(objectname)' \
353 "refs/bisect/skip-*" |
tr '\012' ' ') ||
exit
356 test -n "$skip" && BISECT_OPT
='--bisect-all'
358 bad
=$
(git rev-parse
--verify refs
/bisect
/bad
) &&
359 good
=$
(git for-each-ref
--format='^%(objectname)' \
360 "refs/bisect/good-*" |
tr '\012' ' ') &&
361 eval="git rev-list --bisect-vars $BISECT_OPT $good $bad --" &&
362 eval="$eval $(cat "$GIT_DIR/BISECT_NAMES
")" &&
363 eval=$
(filter_skipped
"$eval" "$skip") &&
366 if [ -z "$bisect_rev" ]; then
367 echo "$bad was both good and bad"
370 if [ "$bisect_rev" = "$bad" ]; then
371 exit_if_skipped_commits
"$bisect_tried"
372 echo "$bisect_rev is first bad commit"
373 git diff-tree
--pretty $bisect_rev
377 # We should exit here only if the "bad"
378 # commit is also a "skip" commit (see above).
379 exit_if_skipped_commits
"$bisect_rev"
381 echo "Bisecting: $bisect_nr revisions left to test after this"
382 git checkout
-q "$bisect_rev" ||
exit
383 git show-branch
"$bisect_rev"
387 bisect_next_check fail
391 case "${DISPLAY+set}${MSYSTEM+set}${SECURITYSESSIONID+set}" in
398 -*) set git log
"$@" ;;
403 not
=$
(git for-each-ref
--format='%(refname)' "refs/bisect/good-*")
404 eval '"$@"' refs
/bisect
/bad
--not $not -- $
(cat "$GIT_DIR/BISECT_NAMES")
408 test -s "$GIT_DIR/BISECT_START" ||
{
409 echo "We are not bisecting."
413 0) branch
=$
(cat "$GIT_DIR/BISECT_START") ;;
414 1) git show-ref
--verify --quiet -- "refs/heads/$1" ||
415 die
"$1 does not seem to be a valid branch"
420 git checkout
"$branch" && bisect_clean_state
423 bisect_clean_state
() {
424 # There may be some refs packed during bisection.
425 git for-each-ref
--format='%(refname) %(objectname)' refs
/bisect
/\
* |
428 git update-ref
-d $ref $hash ||
exit
430 rm -f "$GIT_DIR/BISECT_LOG" &&
431 rm -f "$GIT_DIR/BISECT_NAMES" &&
432 rm -f "$GIT_DIR/BISECT_RUN" &&
433 # Cleanup head-name if it got left by an old version of git-bisect
434 rm -f "$GIT_DIR/head-name" &&
436 rm -f "$GIT_DIR/BISECT_START"
440 test -r "$1" || die
"cannot read $1 for replaying"
442 while read git bisect
command rev
444 test "$git $bisect" = "git bisect" -o "$git" = "git-bisect" ||
continue
445 if test "$git" = "git-bisect"; then
451 cmd
="bisect_start $rev"
454 bisect_write
"$command" "$rev" ;;
456 die
"?? what are you talking about?" ;;
463 bisect_next_check fail
471 # Check for really bad run error.
472 if [ $res -lt 0 -o $res -ge 128 ]; then
473 echo >&2 "bisect run failed:"
474 echo >&2 "exit code $res from '$@' is < 0 or >= 128"
478 # Find current state depending on run success or failure.
479 # A special exit code of 125 means cannot test.
480 if [ $res -eq 125 ]; then
482 elif [ $res -gt 0 ]; then
488 # We have to use a subshell because "bisect_state" can exit.
489 ( bisect_state
$state > "$GIT_DIR/BISECT_RUN" )
492 cat "$GIT_DIR/BISECT_RUN"
494 if grep "first bad commit could be any of" "$GIT_DIR/BISECT_RUN" \
496 echo >&2 "bisect run cannot continue any more"
500 if [ $res -ne 0 ]; then
501 echo >&2 "bisect run failed:"
502 echo >&2 "'bisect_state $state' exited with error code $res"
506 if grep "is first bad commit" "$GIT_DIR/BISECT_RUN" > /dev
/null
; then
507 echo "bisect run success"
527 bisect_state
"$cmd" "$@" ;;
529 # Not sure we want "next" at the UI level anymore.
532 bisect_visualize
"$@" ;;
536 bisect_replay
"$@" ;;
538 cat "$GIT_DIR/BISECT_LOG" ;;